package org.apache.bcel.verifier;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import java.util.ArrayList;
import java.util.List;
import java.util.Set;
import java.util.TreeSet;
import javax.swing.ListModel;
import javax.swing.event.ListDataEvent;
import javax.swing.event.ListDataListener;
import org.apache.bcel.verifier.Verifier;
import org.apache.bcel.verifier.VerifierFactory;
import org.apache.bcel.verifier.VerifierFactoryObserver;
import org.apache.commons.lang3.ArrayUtils;

public class VerifierFactoryListModel implements VerifierFactoryObserver, ListModel<String> {
  private final List<ListDataListener> listeners = new ArrayList<>();
  
  private final Set<String> cache = new TreeSet<>();
  
  public VerifierFactoryListModel() {
    VerifierFactory.attach(this);
    update(null);
  }
  
  public synchronized void addListDataListener(ListDataListener l) {
    this.listeners.add(l);
  }
  
  public synchronized String getElementAt(int index) {
    return ((String[])this.cache.toArray((T[])ArrayUtils.EMPTY_STRING_ARRAY))[index];
  }
  
  public synchronized int getSize() {
    return this.cache.size();
  }
  
  public synchronized void removeListDataListener(ListDataListener l) {
    this.listeners.remove(l);
  }
  
  public synchronized void update(String s) {
    Verifier[] verifiers = VerifierFactory.getVerifiers();
    int verifierLen = verifiers.length;
    this.cache.clear();
    for (Verifier verifier : verifiers)
      this.cache.add(verifier.getClassName()); 
    for (ListDataListener listener : this.listeners)
      listener.contentsChanged(new ListDataEvent(this, 0, 0, verifierLen - 1)); 
  }
}
